﻿Imports System.Diagnostics.Eventing.Reader
Imports System.IO
Imports System.Net.Sockets
Imports System.Windows.Forms.DataVisualization.Charting

Public Class MainForm
    '*******************************************************************************
    '* Stop polling when the form is not visible in order to reduce communications
    '* Copy this section of code to every new form created
    '*******************************************************************************
    Private NotFirstShow As Boolean

    Private Sub Form_VisibleChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.VisibleChanged
        '* Do not start comms on first show in case it was set to disable in design mode
        If NotFirstShow Then
            AdvancedHMIDrivers.Utilities.StopComsOnHidden(components, Me)
        Else
            NotFirstShow = True
        End If
    End Sub

    '***************************************************************
    '* .NET does not close hidden forms, so do it here
    '* to make sure forms are disposed and drivers close
    '***************************************************************
    Private Sub MainForm_FormClosing(sender As Object, e As FormClosingEventArgs) Handles Me.FormClosing
        Dim index As Integer
        While index < My.Application.OpenForms.Count
            If My.Application.OpenForms(index) IsNot Me Then
                My.Application.OpenForms(index).Close()
            End If
            index += 1
        End While
    End Sub

    Private Sub Tank_Level_BasicLabel_TextChanged(sender As Object, e As EventArgs) Handles Tank_Level_BasicLabel.TextChanged
        Dim currentValue As Integer
        Dim maxValue As Integer = 100
        Dim minValue As Integer = 5
        If Integer.TryParse(Tank_Level_BasicLabel.Text, currentValue) Then
            If currentValue < minValue Or currentValue > maxValue Then
                Oops_PictureBox.Visible = True
                Me.BackColor = Color.Red
                OpcDaCom1.BeginWrite("Channel1.Cooling_Tank.Stop_Switch", 1, {"1"})
            End If
        End If
    End Sub

    Private Sub Reset_MomentaryButton_Click(sender As Object, e As EventArgs) Handles Reset_MomentaryButton.Click
        Dim answer As Integer

        answer = MsgBox("Are you sure you wish to reset the system?", MessageBoxButtons.YesNoCancel)
        If answer = DialogResult.Yes Then
            Oops_PictureBox.Visible = False
            Me.BackColor = Color.Black
            OpcDaCom1.BeginWrite("Channel1.Cooling_Tank.Reset_Switch", 1, {"1"})
        End If
    End Sub

    Private Function IsPortOpen(ByVal Host As String, ByVal PortNumber As Integer)
        Dim Client As TcpClient = Nothing
        Try
            Client = New TcpClient(Host, PortNumber)
            Return True
        Catch ex As SocketException
            Return False
        Finally
            If Not Client Is Nothing Then
                Client.Close()
            End If
        End Try
    End Function

    ' Delay startup if OPC server is not yet running
    Private Sub MainForm_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        For counter As Integer = 1 To 5 Step 1
            If IsPortOpen("10.0.255.100", 502) Then
                Exit For
            End If
        Next counter
    End Sub
End Class
